/*----------------------------------------------------------------------
  Produto de Numeros primos III
  ----------------------------------------------------------------------
 */

#include <stdio.h>

#define  PRECISAO    100

void uso();

main()
{
  unsigned long int i, j, inicio, final,
                num_primos = 0, 
                iter_ext = 0,
                iter_int = 0;
  long double produto = 1.0;

  do { 
    printf ("\nEntre com o inicio e final da regiao onde se quer procurar numeros primos: ");
  } while (scanf("%lu %lu", &inicio, &final) != 2);
 
  if (inicio > final)
    uso();
  
  printf("Lista de numeros primos de %lu ateh %lu.\n\n\t", inicio, final);
  
  /* Se for indicado 2 ou 1 como inicio da regiao,
   * imprime 2 e inicia o algoritmo de 3
   */
 if (inicio < 3) {
    printf("%5d ", 2);
    inicio=3;
    num_primos=1;
    produto *= 2;
  }
  
  /* Sempre inicia o algoritmo a partir de um numero impar. */
  if (inicio % 2 == 0)
    inicio++;
  
  for (i = inicio; i <= final; i += 2) {
    iter_ext++;

    /* Verifica se eh primo usando o Crivo de Eratostenes */
    for (j = 3; (i % j != 0) && (j * j <= i); j += 2)
      iter_int++;

    if ( j * j > i ) {
      produto *= i;
      printf("%5lu ", i);
      
      /* Depois de imprimir 10 numeros, muda de linha */
      if (++num_primos % 10 == 0)
	printf("\n\t");
    }
  }
  
  printf("\n\nProduto = %.100Lg\n\n", produto);
  printf("\n\nNmero de iteraes: %5lu %5lu %5lu\n\n", iter_ext, iter_int, iter_ext + iter_int);
  
}

void uso(void)
{
  fprintf(stderr,"-------------------------------------\n");
  fprintf(stderr," Forma de uso: ProdPrimos N M\n");
  fprintf(stderr," \t lista dos numeros primos entre N e M\n");
  fprintf(stderr,"-------------------------------------\n");
  exit(1);
}
